/*
 *		L I S T _ I n s e r t 
 *
 *	This function is called when it is required
 *	to insert a new node at the beginning of a list.
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *	   Email:  dave.walker@icl.com
 *
 *	   Permission to copy and/or distribute granted under the
 *	   following conditions:
 *
 *	   1). This notice must remain intact.
 *	   2). The author is not responsible for the consequences of use
 *		   this software, no matter how awful, even if they
 *		   arise from defects in it.
 *	   3). Altered version must not be represented as being the
 *		   original software.
 *
 *
 *	AMENDMENT HISTORY
 *	~~~~~~~~~~~~~~~~~
 *	22 May 96	DJW   - First version
 *
 *	10 May 99	DJW   - Fixed bug where sequence check was not being done for ordered lists.
 */

#include <liblist.h>
#include "liblistx.h"


int 	LIST_Insert (list_t list, node_t node)
{
	_listmaster_t listmaster;
	listclass_t listclass;

	LIBDEBUG ("LIST_Insert", \
			"'list' parameter is not a valid list pointer", \
			_LIST_ListCheck(list));

	listclass = list->listclass;
	listmaster = listclass->master;

	if (listclass->compare != NULL)
	{
		if (LIST_Compare(list,node,listmaster->first(list)) > 0)
		{
			return LIST_ERROR_SEQUENCE;
		}
	}
	return listmaster->after (list, _LIST_REALNODE(list,node), NULL);
}
