/*
 *		L I S T _ I s M e m b e r
 *
 *	This function is called when it is required to
 *	determine if a particular node is a member of the list.
 *
 *
 * (c) Copyright 1996-2000 David J. Walker
 *	   Email:  dave.walker@icl.com
 *
 *	   Permission to copy and/or distribute granted under the
 *	   following conditions:
 *
 *	   1). This notice must remain intact.
 *	   2). The author is not responsible for the consequences of use
 *		   this software, no matter how awful, even if they
 *		   arise from defects in it.
 *	   3). Altered version must not be represented as being the
 *		   original software.
 *
 *
 *	AMENDMENT HISTORY
 *	~~~~~~~~~~~~~~~~~
 *	07 July 00	DJW   - First version
 *
 */

#include <liblist.h>
#include "liblistx.h"

#undef LIST_IsMember

int 	LIST_IsMember (list_t list, node_t node)
{

	LIBDEBUG ("LIST_IsMember", \
			"'list' parameter is not a valid list pointer", \
			_LIST_ListCheck(list))
	LIBDEBUG ("LIST_IsMember", \
			"'node' parameter is not a valid member of this list type",\
			_LIST_NodeCheck(list,node))

	/*
	 *	Check that we have a valid parameter
	 *	and that the list is not empty.
	 */
	if (node == NULL || NULL == LIST_First(list))
	{
		return LIST_FALSE;
	}
	return (LIST_Index(list, node) != 0 ? LIST_TRUE : LIST_FALSE);
}
