/*
 *      _ L I S T _ L i f o P r e v i o us
 *
 *
 *  This is a routine for finding the previous
 *  node in a single linked list.
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *     Email:  dave.walker@icl.com
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  23 May 96   DJW   - First version
 *
 *  28 May 96   DJW   - Updated 'remove' to allow for the user providing
 *                      a memver to remove who is not on the list!
 */


#include <liblist.h>
#include "liblistx.h"


node_t  _LIST_LifoPrevious    (list_t list, node_t node)
{
#ifdef LIBTEST
	_lifoh_t  lifolist = (_lifoh_t)list;
	_lifo_t	  lifonode = (_lifo_t)node;
#else
#define lifolist ((_lifoh_t)list)
#define lifonode ((_lifo_t)node)
#endif

    _lifo_t   listnode;

    /*
     *  If this is the first node in the
     *  list there cannot be a previous one.
     */
    if (lifolist->nodes == lifonode)
    {
        return NULL;
    }
    /*
     *  Scan the list for a node whose 'next'
     *  pointer points to the current node.
     */
    for (listnode = lifolist->nodes ; 
                listnode != NULL ; listnode = listnode->next)
    {
        if (listnode->next == lifonode)
        {
            break;
        }
    }
    LIBASSERT (listnode != NULL)
    return _LIST_USERNODE(lifolist,listnode);
}


