/*
 *      _ L I S T _ L i f o R e m o v e
 *
 *  This is used to remove a node from a 
 *  linked list that DOES NOT have
 *  a pointer to the last node.
 *
 *	These are:
 *		- (LIFO).
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *     Email:  dave.walker@icl.com
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  23 May 96   DJW   - First version
 *
 *	09 May 99	DJW	  -	Updated to use the new '_LIST_ListRemove' support routine.
 */


#include <liblist.h>
#include "liblistx.h"


int     _LIST_LifoRemove (list_t list, node_t node)
{
	_lifo_t listnode;

	listnode = (_lifo_t)_LIST_ListRemove(list,node);

	if ((long)listnode < 0)
	{
		return (int)((long)listnode);
	}
    return (LIST_ERROR_NONE);
}

